'GUI Library

'$dynamic
OPTION _EXPLICIT
TYPE tVECTOR2dl
  x AS LONG
  y AS LONG
END TYPE

TYPE tQUAD
  a AS tVECTOR2dl
  b AS tVECTOR2dl
END TYPE

TYPE tBOX
  start AS tVECTOR2dl
  finish AS tVECTOR2dl
END TYPE

TYPE tOS
  os AS STRING * 32
  osEnum AS _BYTE
  pathSeparator AS STRING * 1
  workingDirectory AS STRING * 256
  fileListCommand AS STRING * 256
END TYPE

TYPE tTREE
  id AS _UNSIGNED _INTEGER64
  parent AS _UNSIGNED _INTEGER64
  level AS LONG
END TYPE

TYPE tMOUSEBUTTON
  button AS _BYTE
  lastButton AS _BYTE
  time AS SINGLE
  clickCount AS LONG
  PosEdge AS _BYTE
  NegEdge AS _BYTE
  anchorPosition AS tVECTOR2dl
  dropPosition AS tVECTOR2dl
  singleClick AS _BYTE
  doubleClick AS _BYTE
  drag AS _BYTE
END TYPE

TYPE tKEYBOARD
  keyHit AS LONG
  keyReleased AS LONG
  lastKeyHit AS LONG
  lastKeyReleased AS LONG
  r_ctrl AS _UNSIGNED _BYTE
  r_alt AS _UNSIGNED _BYTE
  r_shift AS _UNSIGNED _BYTE
  l_ctrl AS _UNSIGNED _BYTE
  l_alt AS _UNSIGNED _BYTE
  l_shift AS _UNSIGNED _BYTE
END TYPE

TYPE tMOUSE
  mouseMode AS LONG '0 - hidden, 1 - show
  mouseOnScreen AS INTEGER
  mouseIcon AS LONG ' mouse pointer sprite
  position AS tVECTOR2dl
  lastPosition AS tVECTOR2dl
  offset AS tVECTOR2dl
  b1 AS tMOUSEBUTTON
  b2 AS tMOUSEBUTTON
  b3 AS tMOUSEBUTTON
  w AS INTEGER 'wheel
  wCount AS INTEGER 'wheelCount
  hoverOver AS LONG ' id of window currently over
  hoverOverElement AS LONG 'Element which the mouse is touching
END TYPE

TYPE tINPUTDEVICE
  mouse AS tMOUSE
  keyboard AS tKEYBOARD
END TYPE

TYPE tSURFACE
  outer AS LONG ' image that has all of the elements border, titlebar, close
  primary AS LONG ' normal image to be displayed
  enable AS LONG ' highlighted image
  disable AS LONG ' disabled image
  defaultColor AS LONG
  mouseSensitive AS LONG ' Screen with color data that reflects mouse sensitive objects on screen
END TYPE

TYPE tFONTENUMERATION 'bitmap fonts
  fontName AS STRING * 256
  fontSizePixels AS tVECTOR2dl
END TYPE

TYPE tWINDOW
  id AS _INTEGER64
  elementName AS STRING * 64
  tree AS tTREE
  surface AS tSURFACE
  position AS tVECTOR2dl
  size AS tVECTOR2dl
  title AS STRING * 128
  focus AS LONG
  renderOrder AS LONG
  attrib AS _INTEGER64
  update AS _BYTE
END TYPE

TYPE tCHARATTRIB
  attrib AS _UNSIGNED INTEGER ' bit values for underline - 3, bold - 2, italics - 1, normal - 0
  font AS _UNSIGNED INTEGER '
  fontSize AS _UNSIGNED INTEGER
  foregroundColor AS LONG
  backgroundColor AS LONG
END TYPE

TYPE tTEXTBUFFER
  char AS _UNSIGNED _BYTE
  attrib AS tCHARATTRIB
  position AS tVECTOR2dl
END TYPE

TYPE tLABEL
  id AS LONG
  elementName AS STRING * 64
  tree AS tTREE
  position AS tVECTOR2dl
  size AS tVECTOR2dl
  text AS STRING * 1024
END TYPE

TYPE tTEXT
  text AS STRING * 1024
  attrib AS LONG
  maxLen AS LONG
END TYPE

TYPE tCONTROL
  id AS _INTEGER64 ' unique number for control
  userID AS _BYTE ' a number set by user
  surface AS tSURFACE
  controlType AS _BYTE
  elementName AS STRING * 64
  elementText AS tTEXT
  style AS LONG
  bitmap AS LONG
  textColor AS LONG
  controlColor AS LONG
  enableColor AS LONG
  tree AS tTREE ' contains window parent information
  position AS tVECTOR2dl
  size AS tVECTOR2dl
  status AS _BYTE ' output of control
  enabled AS _BYTE ' user able to interact with control
  visible AS _BYTE ' visible
END TYPE

TYPE tGENERAL
  focus AS _UNSIGNED _INTEGER64
  updateAll AS _BYTE
  tree AS tTREE
  os AS tOS
  idevice AS tINPUTDEVICE
END TYPE

TYPE tSTRINGTUPLE
  contextName AS STRING * 64
  arg AS STRING * 4096
END TYPE

TYPE tMOUSESETTINGS
  doubleclickdelay AS _FLOAT
END TYPE

TYPE tWINDOWSETTINGS
  elementColor AS LONG
  windowCloseSprite AS LONG
  cornerSize AS INTEGER
  borderThickness AS INTEGER
END TYPE

TYPE tSCREENSETTINGS
  h AS LONG
  w AS LONG
  bpp AS _BYTE
  background AS LONG
  font AS LONG
  fontSize AS INTEGER
  fullscreen AS _BYTE
END TYPE

TYPE tSETTINGS
  mouse AS tMOUSESETTINGS
  scrn AS tSCREENSETTINGS
  win AS tWINDOWSETTINGS
END TYPE

TYPE tSPRITE
  sprite AS LONG
  spriteName AS STRING * 32
  hash AS _INTEGER64
END TYPE

TYPE tSPRITESHEET
  file AS STRING * 256
  mapWidth AS LONG ' gamemap width
  mapHeight AS LONG ' gamemap height
  spriteWidth AS LONG 'sprite width in pixels
  spriteHeight AS LONG 'sprite height in pixels
  spriteImageX AS LONG 'size of spritemap image in Sprites
  spriteCount AS LONG 'number of Sprites in the image
  spriteMap AS LONG ' spritemap image
  spritesize AS LONG 'same as spritewidth * spriteheight, if square
  spritePadding AS LONG ' distance between Sprites
  numberOfSpritesX AS LONG 'same as w
  numberOfSpritesY AS LONG 'same as h
  numberOfSprites AS LONG 'w*h
  spriteScale AS LONG 'sprite to physics world scale
END TYPE

TYPE tELAPSEDTIMER
  start AS _FLOAT
  last AS _FLOAT
  duration AS _FLOAT
END TYPE

TYPE tFSM
  currentState AS LONG
  previousState AS LONG
  timerState AS tELAPSEDTIMER
  arg1 AS tVECTOR2dl ' keep some info on goals
  arg2 AS tVECTOR2dl
  arg3 AS _FLOAT
  arg4 AS LONG
END TYPE


CONST cFALSE = 0
CONST cTRUE = -1

CONST cOS_UNKNOWN = 0
CONST cOS_WIN = 1
CONST cOS_LINUX = 2
CONST cOS_MACOSX = 3

CONST cWINRESIZEUP = &B00000001
CONST cWINRESIZEDOWN = &B00000010
CONST cWINRESIZELEFT = &B00000100
CONST cWINRESIZERIGHT = &B00001000
CONST cWINRESIZEUPLEFT = cWINRESIZEUP OR cWINRESIZELEFT
CONST cWINRESIZEUPRIGHT = cWINRESIZEUP OR cWINRESIZERIGHT
CONST cWINRESIZEDOWNLEFT = cWINRESIZEDOWN OR cWINRESIZELEFT
CONST cWINRESIZEDOWNRIGHT = cWINRESIZEDOWN OR cWINRESIZERIGHT

CONST cWINTITLEBAR = &B00010000
CONST cWINCLOSEBUTTON = &B00100000
CONST cWINCONTROL = &B01000000

CONST cWINATTRIB_RESIZEABLE = &B0000000000000001
CONST cWINATTRIB_TITLEBAR = &B0000000000000010
CONST cWINATTRIB_TITLECLOSE = &B0000000000000100

CONST cWIN_CONTROL_LABEL = 1
CONST cWIN_CONTROL_BUTTON = 2
CONST cWIN_CONTROL_TOGGLE_BUTTON = 3
CONST cWIN_CONTROL_RADIO_BUTTON = 4

CONST cFSM_IDLE = 0
CONST cFSM_INIT = 1
CONST cFSM_RUN = 2

CONST cCONTROL_STYLE_DRAW = 0
CONST cCONTROL_STYLE_BITMAP = 1

CONST cCIRCLE_STYLE_NOFILL = 0
CONST cCIRCLE_STYLE_FILLED = 1

CONST cTEXT_JUSTIFY_LEFT = 0
CONST cTEXT_JUSTIFY_CENTER = 1
CONST cTEXT_JUSTIFY_RIGHT = 2

main

SUB main STATIC

  DIM AS tGENERAL general
  DIM AS tSETTINGS settings
  DIM AS tSURFACE surface(0)
  DIM AS tWINDOW win(0), tempW
  DIM AS tSTRINGTUPLE con(0), wcon(0)
  DIM AS _BYTE element
  DIM AS _INTEGER64 mainWin, controlWin
  DIM AS _INTEGER64 fw, fc
  DIM AS tSPRITESHEET spriteMap(0)
  DIM AS tSPRITE sprites(0)

  DIM AS tCONTROL control(0), tempC

  DIM file(0) AS STRING * 256
  DIM AS tFSM winFSM
  DIM AS LONG tempID

  OSinit general.os
  OSDirectoryListing general.os, _CWD$, "", file()
  XMLparse _CWD$ + general.os.pathSeparator + "ini.xml", con()
  init settings, con(), general.os, spriteMap(), sprites()

  settings.win.windowCloseSprite = spriteNameToID(sprites(), "WINDOW CLOSE")

  surface(0).defaultColor = settings.scrn.background
  initScreen surface(0), settings.scrn.w, settings.scrn.h, settings.scrn.bpp

  DIM AS LONG iter, iter2, controlID

  DO
    clearScreen surface(0)
    handleInputDevice settings, general.idevice
    IF _RESIZE THEN
      DIM newSize AS tVECTOR2dl
      IF _RESIZEWIDTH > _WIDTH(0) OR _RESIZEHEIGHT > _HEIGHT(0) THEN
        newSize.x = _RESIZEWIDTH * 1.5: newSize.y = _RESIZEHEIGHT * 1.5
        settings.scrn.w = newSize.x: settings.scrn.h = newSize.y
        resizeScreen surface(0), newSize
      END IF
    END IF
    SELECT CASE winFSM.currentState
      CASE cFSM_IDLE
        FSMChangeState winFSM, cFSM_INIT
      CASE cFSM_INIT

        XMLparse _CWD$ + general.os.pathSeparator + "UI.xml", wcon()
        initWin general, win(), control(), settings, wcon(), spriteMap(), sprites()

        mainWin = findWinIDByName(win(), "Window Info")
        controlWin = findWinIDByName(win(), "Control")
        general.focus = controlWin
        general.updateAll = cTRUE
        FSMChangeState winFSM, cFSM_RUN
      CASE cFSM_RUN
        element = _RED(general.idevice.mouse.hoverOverElement)
        controlID = _GREEN(general.idevice.mouse.hoverOverElement)
        ' Set offset or local window coordinates and move focus to new window
        IF general.idevice.mouse.b1.PosEdge AND general.idevice.mouse.hoverOver <> -1 THEN
          general.idevice.mouse.offset.x = general.idevice.mouse.position.x - win(general.idevice.mouse.hoverOver).position.x
          general.idevice.mouse.offset.y = general.idevice.mouse.position.y - win(general.idevice.mouse.hoverOver).position.y
          'move window to top of drawing order
          tempW = win(general.idevice.mouse.hoverOver)
          iter = general.idevice.mouse.hoverOver

          DO
            IF iter > 0 THEN
              win(iter) = win(iter - 1)
            END IF
            iter = iter - 1
          LOOP WHILE iter > 0
          win(0) = tempW
          general.focus = win(0).id
          general.updateAll = cTRUE


          IF (element AND cWINCLOSEBUTTON) THEN
            winDestroy win(), general.idevice.mouse.hoverOver
            general.focus = mainWin
            general.updateAll = cTRUE
          END IF

          IF element AND cWINCONTROL AND general.focus = win(general.idevice.mouse.hoverOver).id THEN
            tempID = findControl&(general, win(), control(), controlID)
            IF tempID >= 0 THEN
              SELECT CASE control(tempID).controlType
                CASE cWIN_CONTROL_LABEL
                CASE cWIN_CONTROL_BUTTON
                  control(tempID).enabled = cTRUE
                CASE cWIN_CONTROL_TOGGLE_BUTTON
                  IF control(tempID).enabled THEN
                    control(tempID).enabled = cFALSE
                  ELSE
                    control(tempID).enabled = cTRUE
                  END IF
                CASE cWIN_CONTROL_RADIO_BUTTON
                  FOR iter2 = 0 TO UBOUND(control)
                    IF control(iter2).tree.parent = win(general.idevice.mouse.hoverOver).id THEN
                      IF control(iter2).controlType = cWIN_CONTROL_RADIO_BUTTON THEN
                        control(iter2).enabled = cFALSE
                      END IF
                    END IF
                  NEXT
                  IF control(tempID).enabled THEN
                    control(tempID).enabled = cFALSE
                  ELSE
                    control(tempID).enabled = cTRUE
                  END IF
              END SELECT
              general.updateAll = cTRUE
            END IF
          END IF
        END IF

        IF general.idevice.mouse.b1.drag THEN
          IF general.idevice.mouse.hoverOver = -1 THEN
            LINE (general.idevice.mouse.b1.anchorPosition.x, general.idevice.mouse.b1.anchorPosition.y)-(general.idevice.mouse.position.x, general.idevice.mouse.position.y), _RGB(255, 0, 0), B , &B0000111100001111
          ELSE
            IF element AND cWINTITLEBAR THEN
              win(general.idevice.mouse.hoverOver).position.x = general.idevice.mouse.position.x - general.idevice.mouse.offset.x
              win(general.idevice.mouse.hoverOver).position.y = general.idevice.mouse.position.y - general.idevice.mouse.offset.y
            END IF

            IF win(general.idevice.mouse.hoverOver).attrib AND cWINATTRIB_RESIZEABLE THEN
              IF element THEN
                IF element AND cWINRESIZEUP THEN
                  win(general.idevice.mouse.hoverOver).position.y = general.idevice.mouse.position.y
                  win(general.idevice.mouse.hoverOver).size.y = win(general.idevice.mouse.hoverOver).size.y + general.idevice.mouse.b1.anchorPosition.y - general.idevice.mouse.position.y
                  general.idevice.mouse.b1.anchorPosition.y = general.idevice.mouse.position.y
                END IF
                IF element AND cWINRESIZEDOWN THEN
                  win(general.idevice.mouse.hoverOver).size.y = general.idevice.mouse.position.y - win(general.idevice.mouse.hoverOver).position.y + 2
                END IF
                IF element AND cWINRESIZELEFT THEN
                  win(general.idevice.mouse.hoverOver).position.x = general.idevice.mouse.position.x
                  win(general.idevice.mouse.hoverOver).size.x = win(general.idevice.mouse.hoverOver).size.x + general.idevice.mouse.b1.anchorPosition.x - general.idevice.mouse.position.x
                  general.idevice.mouse.b1.anchorPosition.x = general.idevice.mouse.position.x
                END IF
                IF element AND cWINRESIZERIGHT THEN
                  win(general.idevice.mouse.hoverOver).size.x = general.idevice.mouse.position.x - win(general.idevice.mouse.hoverOver).position.x + 2
                END IF
                buildWindow general, win(general.idevice.mouse.hoverOver), settings, spriteMap(), sprites()
                general.updateAll = cTRUE
              END IF
            END IF
          END IF
        END IF

        'IF general.idevice.mouse.b2.drag THEN
        '  LINE (general.idevice.mouse.b2.anchorPosition.x, general.idevice.mouse.b2.anchorPosition.y) _
        '      -(general.idevice.mouse.position.x, general.idevice.mouse.position.y), _RGB(255, 255, 0), B , &B0000111100001111
        'END IF

        'IF general.idevice.mouse.b3.drag THEN
        '  LINE (general.idevice.mouse.b3.anchorPosition.x, general.idevice.mouse.b3.anchorPosition.y) _
        '      -(general.idevice.mouse.position.x, general.idevice.mouse.position.y), _RGB(255, 0, 255), B , &B0000111100001111
        'END IF

        IF general.idevice.mouse.b1.doubleClick AND element <> 64 THEN
          tempW.size.x = 400
          tempW.size.y = 200
          tempW.position = general.idevice.mouse.position
          tempW.surface.defaultColor = _RGB32(55, 72, 127)
          tempW.attrib = cWINATTRIB_RESIZEABLE OR cWINATTRIB_TITLEBAR OR cWINATTRIB_TITLECLOSE
          tempW.tree.parent = general.focus
          createWindowEx general, settings, win(), spriteMap(), sprites(), tempW
          win(findWinByID(win(), tempW.id)).title = "Sub " + STR$(tempW.id)
          general.focus = tempW.id
          general.updateAll = cTRUE
        END IF

        IF general.idevice.mouse.b1.NegEdge THEN
          IF element AND cWINCONTROL THEN
            tempID = findControl&(general, win(), control(), controlID)
            IF tempID >= 0 THEN
              SELECT CASE control(tempID).controlType
                CASE cWIN_CONTROL_LABEL
                CASE cWIN_CONTROL_BUTTON
                CASE cWIN_CONTROL_TOGGLE_BUTTON
                CASE cWIN_CONTROL_RADIO_BUTTON
              END SELECT
              general.updateAll = cTRUE
            END IF
          END IF
          'cleanup any buttons left on
          FOR iter2 = 0 TO UBOUND(control)
            IF control(iter2).controlType = cWIN_CONTROL_BUTTON THEN
              control(iter2).enabled = cFALSE
              general.updateAll = cTRUE
            END IF
          NEXT
        END IF

        fw = findWinByID(win(), mainWin)
        fc = findWinByID(win(), controlWin)
        'Update mainWin
        IF UBOUND(win) > 0 THEN
          IF fw <> -1 THEN
            _DEST win(fw).surface.primary
            _PRINTMODE _KEEPBACKGROUND
            CLS 0, _RGB32(6, 33, 39)
            LOCATE 1
            FOR iter = 0 TO UBOUND(win) - 1
              PRINT iter; " w: "; trim$(win(iter).title)
            NEXT
            PRINT "Focus:"; general.focus
            PRINT "HO: ";
            IF general.idevice.mouse.hoverOver >= 0 THEN
              PRINT trim$(win(general.idevice.mouse.hoverOver).title)
            ELSE
              PRINT " none"
            END IF
            PRINT "ConID:"; controlID
            PRINT "HOE: "; element
            _DEST 0
          END IF
        END IF

        'iter = 0
        'DO WHILE iter < UBOUND(win)
        '  IF iter <> fw AND iter <> fc THEN
        '    _DEST win(iter).surface.primary
        '    '_PRINTMODE _KEEPBACKGROUND
        '    'CLS 0, _RGB32(6, 33, 39)
        '    'LOCATE 1
        '    'PRINT "Parent:"; win(iter).tree.parent
        '    _DEST 0
        '  END IF
        '  iter = iter + 1
        'LOOP
    END SELECT

    renderWindows general, settings, surface(0), win(), general.idevice, spriteMap(), sprites(), control()
    _DISPLAY
    _LIMIT 240

  LOOP UNTIL general.idevice.keyboard.keyHit = 27
  _MOUSESHOW
  SYSTEM 1
END SUB

SUB ________SCREEN_ROUTINES (): END SUB

SUB initScreen (surface AS tSURFACE, w AS LONG, h AS LONG, bpp AS _BYTE)
  LOCATE 1
  PRINT "Please Wait ..."
  _DELAY 1
  surface.primary = _NEWIMAGE(w, h, bpp)
  surface.outer = _NEWIMAGE(w, h, bpp)
  surface.mouseSensitive = _NEWIMAGE(w, h, 32)
  SCREEN surface.primary
  _DEST surface.primary
  _SOURCE surface.primary

END SUB

SUB clearScreen (surface AS tSURFACE)
  _DEST surface.primary
  CLS 0, surface.defaultColor
END SUB

SUB resizeScreen (surface AS tSURFACE, newSize AS tVECTOR2dl)
  DIM AS LONG newLargerImageOuter, newLargerImagePrimary, newLargerImageMS
  newLargerImageOuter = _NEWIMAGE(newSize.x, newSize.y, 32)
  newLargerImagePrimary = _NEWIMAGE(newSize.x, newSize.y, 32)
  newLargerImageMS = _NEWIMAGE(newSize.x, newSize.y, 32)
  _FREEIMAGE surface.primary
  _FREEIMAGE surface.outer
  _FREEIMAGE surface.mouseSensitive
  surface.primary = newLargerImagePrimary
  surface.outer = newLargerImageOuter
  surface.mouseSensitive = newLargerImageMS
END SUB

SUB ________INPUT_ROUTINES (): END SUB
SUB handleInputDevice (settings AS tSETTINGS, iDevice AS tINPUTDEVICE)

  iDevice.mouse.lastPosition = iDevice.mouse.position
  iDevice.mouse.b1.lastButton = iDevice.mouse.b1.button
  iDevice.mouse.b2.lastButton = iDevice.mouse.b2.button
  iDevice.mouse.b3.lastButton = iDevice.mouse.b3.button
  iDevice.keyboard.lastKeyHit = iDevice.keyboard.keyHit

  iDevice.keyboard.keyHit = _KEYHIT
  DO WHILE _MOUSEINPUT
    iDevice.mouse.position.x = _MOUSEX
    iDevice.mouse.position.y = _MOUSEY
    iDevice.mouse.b1.button = _MOUSEBUTTON(1)
    iDevice.mouse.b2.button = _MOUSEBUTTON(2)
    iDevice.mouse.b3.button = _MOUSEBUTTON(3)
    iDevice.mouse.w = _MOUSEWHEEL
    iDevice.mouse.wCount = iDevice.mouse.wCount + iDevice.mouse.w
  LOOP
  ' Button Down
  IF iDevice.mouse.b1.button AND NOT iDevice.mouse.b1.lastButton THEN
    iDevice.mouse.b1.anchorPosition = iDevice.mouse.position
    iDevice.mouse.b1.PosEdge = cTRUE
    iDevice.mouse.b1.time = TIMER(.001)
  ELSE
    iDevice.mouse.b1.PosEdge = cFALSE
    IF TIMER(.001) - iDevice.mouse.b1.time > settings.mouse.doubleclickdelay THEN
      iDevice.mouse.b1.clickCount = 0
    END IF
  END IF

  IF iDevice.mouse.b2.button AND NOT iDevice.mouse.b2.lastButton THEN
    iDevice.mouse.b2.anchorPosition = iDevice.mouse.position
    iDevice.mouse.b2.PosEdge = cTRUE
    iDevice.mouse.b2.time = TIMER(.001)
  ELSE
    iDevice.mouse.b2.PosEdge = cFALSE
    IF TIMER(.001) - iDevice.mouse.b2.time > settings.mouse.doubleclickdelay THEN
      iDevice.mouse.b2.clickCount = 0
    END IF
  END IF

  IF iDevice.mouse.b3.button AND NOT iDevice.mouse.b3.lastButton THEN
    iDevice.mouse.b3.anchorPosition = iDevice.mouse.position
    iDevice.mouse.b3.PosEdge = cTRUE
    iDevice.mouse.b3.time = TIMER(.001)
  ELSE
    iDevice.mouse.b3.PosEdge = cFALSE
    IF TIMER(.001) - iDevice.mouse.b3.time > settings.mouse.doubleclickdelay THEN
      iDevice.mouse.b3.clickCount = 0
    END IF
  END IF

  'Button Release
  IF NOT iDevice.mouse.b1.button AND iDevice.mouse.b1.lastButton THEN
    iDevice.mouse.b1.dropPosition = iDevice.mouse.position
    iDevice.mouse.b1.NegEdge = cTRUE
    IF TIMER(.001) - iDevice.mouse.b1.time < settings.mouse.doubleclickdelay THEN
      iDevice.mouse.b1.clickCount = iDevice.mouse.b1.clickCount + 1
      iDevice.mouse.b1.time = TIMER(.001)
    ELSE
      iDevice.mouse.b1.clickCount = 0
    END IF
  ELSE
    iDevice.mouse.b1.NegEdge = cFALSE
  END IF

  IF NOT iDevice.mouse.b2.button AND iDevice.mouse.b2.lastButton THEN
    iDevice.mouse.b2.dropPosition = iDevice.mouse.position
    iDevice.mouse.b2.NegEdge = cTRUE
    IF TIMER(.001) - iDevice.mouse.b2.time < settings.mouse.doubleclickdelay THEN
      iDevice.mouse.b2.clickCount = iDevice.mouse.b2.clickCount + 1
      iDevice.mouse.b2.time = TIMER(.001)
    ELSE
      iDevice.mouse.b2.clickCount = 0
    END IF
  ELSE
    iDevice.mouse.b2.NegEdge = cFALSE
  END IF

  IF NOT iDevice.mouse.b3.button AND iDevice.mouse.b3.lastButton THEN
    iDevice.mouse.b3.dropPosition = iDevice.mouse.position
    iDevice.mouse.b3.PosEdge = cTRUE
    IF TIMER(.001) - iDevice.mouse.b3.time < settings.mouse.doubleclickdelay THEN
      iDevice.mouse.b3.clickCount = iDevice.mouse.b3.clickCount + 1
      iDevice.mouse.b3.time = TIMER(.001)
    ELSE
      iDevice.mouse.b3.clickCount = 0
    END IF
  ELSE
    iDevice.mouse.b3.PosEdge = cFALSE
  END IF

  iDevice.mouse.b1.drag = iDevice.mouse.b1.button AND (iDevice.mouse.position.x <> iDevice.mouse.b1.anchorPosition.x OR iDevice.mouse.position.y <> iDevice.mouse.b1.anchorPosition.y)
  iDevice.mouse.b2.drag = iDevice.mouse.b2.button AND (iDevice.mouse.position.x <> iDevice.mouse.b2.anchorPosition.x OR iDevice.mouse.position.y <> iDevice.mouse.b2.anchorPosition.y)
  iDevice.mouse.b3.drag = iDevice.mouse.b3.button AND (iDevice.mouse.position.x <> iDevice.mouse.b3.anchorPosition.x OR iDevice.mouse.position.y <> iDevice.mouse.b3.anchorPosition.y)

  iDevice.mouse.b1.doubleClick = (iDevice.mouse.b1.NegEdge AND iDevice.mouse.b1.clickCount = 2)
  iDevice.mouse.b2.doubleClick = (iDevice.mouse.b2.NegEdge AND iDevice.mouse.b2.clickCount = 2)
  iDevice.mouse.b3.doubleClick = (iDevice.mouse.b3.NegEdge AND iDevice.mouse.b3.clickCount = 2)

  iDevice.mouse.b1.singleClick = (iDevice.mouse.b1.NegEdge AND iDevice.mouse.b1.clickCount = 1)
  iDevice.mouse.b2.singleClick = (iDevice.mouse.b2.NegEdge AND iDevice.mouse.b2.clickCount = 1)
  iDevice.mouse.b3.singleClick = (iDevice.mouse.b3.NegEdge AND iDevice.mouse.b3.clickCount = 1)

END SUB

SUB ________WINDOW_ROUTINES (): END SUB

SUB createWindowEx (general AS tGENERAL, settings AS tSETTINGS, win() AS tWINDOW, spriteMaps() AS tSPRITESHEET, sprites() AS tSPRITE, w AS tWINDOW)
  w.id = uniqueNumber
  w.surface.primary = _NEWIMAGE(w.size.x * 2, w.size.y * 2, 32)
  w.surface.outer = _NEWIMAGE(w.size.x * 2, w.size.y * 2, 32)
  w.surface.mouseSensitive = _NEWIMAGE(w.size.x * 2, w.size.y * 2, 32)

  buildWindow general, w, settings, spriteMaps(), sprites()
  winStackAddToTop win(), w
END SUB

SUB createWindow (general AS tGENERAL, settings AS tSETTINGS, win() AS tWINDOW, spriteMap() AS tSPRITESHEET, sprites() AS tSPRITE, position AS tVECTOR2dl, size AS tVECTOR2dl)
  DIM AS tWINDOW tw

  tw.id = uniqueNumber

  tw.position = position
  tw.size = size

  tw.surface.primary = _NEWIMAGE(tw.size.x * 2, tw.size.y * 2, 32)
  tw.surface.outer = _NEWIMAGE(tw.size.x * 2, tw.size.y * 2, 32)
  tw.surface.mouseSensitive = _NEWIMAGE(tw.size.x * 2, tw.size.y * 2, 32)

  tw.surface.defaultColor = _RGB32(RND * 255, RND * 255, RND * 255)

  tw.focus = cTRUE
  tw.attrib = cWINATTRIB_RESIZEABLE OR cWINATTRIB_TITLEBAR

  buildWindow general, tw, settings, spriteMap(), sprites()
  winStackAddToTop win(), tw
END SUB

SUB buildWindow (general AS tGENERAL, win AS tWINDOW, settings AS tSETTINGS, spriteMap() AS tSPRITESHEET, sprites() AS tSPRITE)
  IF win.size.x < 80 THEN win.size.x = 80
  IF win.size.y < 80 THEN win.size.y = 80
  IF win.position.x < 0 THEN win.position.x = 0
  IF win.position.y < 0 THEN win.position.y = 0

  ' Resize
  IF win.size.x > _WIDTH(win.surface.outer) OR win.size.y > _HEIGHT(win.surface.outer) THEN
    DIM newSize AS tVECTOR2dl
    newSize.x = win.size.x * 1.5
    newSize.y = win.size.y * 1.5
    resizeScreen win.surface, newSize
  END IF

  _DEST win.surface.mouseSensitive
  CLS , _RGB32(0, 0, 0)

  _DEST win.surface.primary
  _FONT settings.scrn.font
  CLS , _RGB32(6, 33, 39)

  buildResizeBorder general, win, settings
  buildTitleBar general, win, settings, spriteMap()

END SUB

SUB buildTitleBar (general AS tGENERAL, win AS tWINDOW, settings AS tSETTINGS, spriteMap() AS tSPRITESHEET)
  DIM AS LONG focusColor
  DIM AS tQUAD q
  _DEST win.surface.outer
  _FONT settings.scrn.font

  IF win.attrib AND cWINATTRIB_TITLEBAR THEN
    IF general.focus = win.id THEN
      focusColor = adjustColor(win.surface.defaultColor, 1)
    ELSE
      focusColor = adjustColor(win.surface.defaultColor, .75)
    END IF

    LINE (0, 0)-(win.size.x, _FONTHEIGHT + settings.win.borderThickness), focusColor, BF
    _PRINTSTRING (win.size.x * .05, 0), trim$(win.title)

    IF win.attrib AND cWINATTRIB_TITLECLOSE THEN
      spriteMapImagePosition settings.win.windowCloseSprite, spriteMap(0), q
      _PUTIMAGE (win.size.x - (settings.win.cornerSize * 2), 1), spriteMap(0).spriteMap, , (q.a.x, q.a.y)-(q.b.x, q.b.y)
    END IF
  END IF

  _DEST win.surface.mouseSensitive
  _FONT settings.scrn.font
  IF win.attrib AND cWINATTRIB_TITLEBAR THEN
    LINE (settings.win.borderThickness, _
          settings.win.borderThickness)-(win.size.x - settings.win.borderThickness, _FONTHEIGHT+settings.win.borderThickness), _RGB32(cWINTITLEBAR, 0, 0), BF
    IF win.attrib AND cWINATTRIB_TITLECLOSE THEN
      LINE (win.size.x - (settings.win.cornerSize * 2), 1)-(win.size.x - (settings.win.cornerSize * 2) + spriteMap(0).spriteWidth, spriteMap(0).spriteHeight + 1), _RGB32(cWINCLOSEBUTTON, 0, 0), BF
    END IF
  END IF
END SUB

SUB buildResizeBorder (general AS tGENERAL, win AS tWINDOW, settings AS tSETTINGS)
  DIM AS LONG focusColor
  _DEST win.surface.outer
  _FONT settings.scrn.font
  _PRINTMODE _KEEPBACKGROUND

  IF win.attrib AND cWINATTRIB_RESIZEABLE THEN
    IF general.focus = win.id THEN
      focusColor = adjustColor(win.surface.defaultColor, 1)
    ELSE
      focusColor = adjustColor(win.surface.defaultColor, .75)
    END IF

    LINE (settings.win.cornerSize, 0)-(win.size.x - (settings.win.cornerSize * 2), settings.win.borderThickness), focusColor, BF
    LINE (settings.win.cornerSize, win.size.y)-(win.size.x - settings.win.cornerSize, win.size.y - settings.win.borderThickness), focusColor, BF
    LINE (0, settings.win.cornerSize)-(settings.win.borderThickness, win.size.y - settings.win.cornerSize), focusColor, BF
    LINE (win.size.x - settings.win.borderThickness, settings.win.cornerSize)-(win.size.x, win.size.y - settings.win.cornerSize), focusColor, BF

    LINE (0, 0)-(settings.win.cornerSize, settings.win.cornerSize), focusColor, BF
    LINE (win.size.x - settings.win.cornerSize, 0)-(win.size.x, settings.win.cornerSize), focusColor, BF
    LINE (0, win.size.y - settings.win.cornerSize)-(settings.win.cornerSize, win.size.y), focusColor, BF
    LINE (win.size.x - settings.win.cornerSize, win.size.y - settings.win.cornerSize)-(win.size.x, win.size.y), focusColor, BF

    _DEST win.surface.mouseSensitive

    LINE (settings.win.cornerSize, 0)-(win.size.x - settings.win.cornerSize, settings.win.borderThickness), _RGB32(cWINRESIZEUP, 0, 0), BF
    LINE (settings.win.cornerSize, win.size.y)-(win.size.x - settings.win.cornerSize, win.size.y - settings.win.borderThickness), _RGB32(cWINRESIZEDOWN, 0, 0), BF
    LINE (0, settings.win.cornerSize)-(settings.win.borderThickness, win.size.y - settings.win.cornerSize), _RGB32(cWINRESIZELEFT, 0, 0), BF
    LINE (win.size.x - settings.win.borderThickness, settings.win.cornerSize)-(win.size.x, win.size.y - settings.win.cornerSize), _RGB32(cWINRESIZERIGHT, 0, 0), BF

    LINE (0, 0)-(settings.win.cornerSize, settings.win.cornerSize), _RGB32(cWINRESIZEUPLEFT, 0, 0), BF
    LINE (win.size.x - settings.win.cornerSize, 0)-(win.size.x, settings.win.cornerSize), _RGB32(cWINRESIZEUPRIGHT, 0, 0), BF
    LINE (0, win.size.y - settings.win.cornerSize)-(settings.win.cornerSize, win.size.y), _RGB32(cWINRESIZEDOWNLEFT, 0, 0), BF
    LINE (win.size.x - settings.win.cornerSize, win.size.y - settings.win.cornerSize)-(win.size.x, win.size.y), _RGB32(cWINRESIZEDOWNRIGHT, 0, 0), BF
  END IF
END SUB

SUB buildControlEx (general AS tGENERAL, control AS tCONTROL, settings AS tSETTINGS, spriteMap() AS tSPRITESHEET, sprites() AS tSPRITE)
  DIM AS tQUAD q
  DIM AS LONG pw, ph, px, py, rbSelected, rbUnselected
  SELECT CASE control.controlType
    CASE cWIN_CONTROL_LABEL, cWIN_CONTROL_BUTTON, cWIN_CONTROL_TOGGLE_BUTTON

      pw = _PRINTWIDTH(trim$(control.elementText.text))
      ph = _FONTHEIGHT
      SELECT CASE control.elementText.attrib
        CASE cTEXT_JUSTIFY_LEFT
          px = 0
          py = (control.size.y - ph) / 2
        CASE cTEXT_JUSTIFY_CENTER
          px = (control.size.x - pw) / 2
          py = (control.size.y - ph) / 2
        CASE cTEXT_JUSTIFY_RIGHT
          px = control.size.x - pw
          py = (control.size.y - ph) / 2
      END SELECT


      control.surface.primary = _NEWIMAGE(control.size.x, control.size.y, 32)
      _DEST control.surface.primary
      _FONT settings.scrn.font
      _PRINTMODE _KEEPBACKGROUND
      LINE (0, 0)-(control.size.x, control.size.y), control.controlColor, BF
      COLOR control.textColor
      _PRINTSTRING (px, py), trim$(control.elementText.text)
      control.surface.enable = _NEWIMAGE(control.size.x, control.size.y, 32)
      _DEST control.surface.enable
      _FONT settings.scrn.font
      _PRINTMODE _KEEPBACKGROUND
      LINE (0, 0)-(control.size.x, control.size.y), control.enableColor, BF
      COLOR control.textColor
      _PRINTSTRING (px, py), trim$(control.elementText.text)
      control.surface.disable = _NEWIMAGE(control.size.x, control.size.y, 32)
      _DEST control.surface.disable
      _FONT settings.scrn.font
      _PRINTMODE _KEEPBACKGROUND
      LINE (0, 0)-(control.size.x, control.size.y), adjustColor(control.controlColor, .5), BF
      COLOR adjustColor(control.textColor, .5)
      _PRINTSTRING (px, py), trim$(control.elementText.text)
    CASE cWIN_CONTROL_RADIO_BUTTON
      px = control.size.x - _PRINTWIDTH(trim$(control.elementText.text))
      py = (control.size.y / 2) - (_FONTHEIGHT / 2)
      control.surface.primary = _NEWIMAGE(control.size.x, control.size.y, 32)
      control.surface.enable = _NEWIMAGE(control.size.x, control.size.y, 32)
      _DEST control.surface.enable
      _FONT settings.scrn.font
      _PRINTMODE _KEEPBACKGROUND
      COLOR control.textColor
      _PRINTSTRING (px, py), trim$(control.elementText.text)
      IF control.style = cCONTROL_STYLE_DRAW THEN
        CircleBresenham control.size.x / 2, control.size.y / 2, control.size.y / 2 - 1, control.enableColor, cCIRCLE_STYLE_NOFILL
        CircleBresenham control.size.x / 2, control.size.y / 2, control.size.y / 4, control.enableColor, cCIRCLE_STYLE_FILLED
      ELSE IF control.style = cCONTROL_STYLE_BITMAP THEN
          rbSelected = spriteNameToID(sprites(), "CIRCLE FILLED")
          spriteMapImagePosition rbSelected, spriteMap(0), q
          _PUTIMAGE (0, 0)-(control.size.y, control.size.y), spriteMap(0).spriteMap, , (q.a.x, q.a.y)-(q.b.x, q.b.y)
        END IF
      END IF
      control.surface.disable = _NEWIMAGE(control.size.x, control.size.y, 32)
      _DEST control.surface.disable
      _FONT settings.scrn.font
      _PRINTMODE _KEEPBACKGROUND
      COLOR control.textColor
      _PRINTSTRING (px, py), trim$(control.elementText.text)
      IF control.style = cCONTROL_STYLE_DRAW THEN
        CircleBresenham control.size.x / 2, control.size.y / 2, control.size.y / 2 - 1, control.enableColor, cCIRCLE_STYLE_NOFILL
        CircleBresenham control.size.x / 2, control.size.y / 2, control.size.y / 4, adjustColor(control.controlColor, .5), cCIRCLE_STYLE_FILLED
      ELSE IF control.style = cCONTROL_STYLE_BITMAP THEN
          rbUnselected = spriteNameToID(sprites(), "CIRCLE UNFILLED")
          spriteMapImagePosition rbUnselected, spriteMap(0), q
          _PUTIMAGE (0, 0)-(control.size.y, control.size.y), spriteMap(0).spriteMap, , (q.a.x, q.a.y)-(q.b.x, q.b.y)
        END IF
      END IF

  END SELECT
END SUB

SUB buildControl (general AS tGENERAL, win AS tWINDOW, control() AS tCONTROL, settings AS tSETTINGS, spriteMap() AS tSPRITESHEET, sprites() AS tSPRITE)
  DIM AS LONG iter
  DO WHILE iter < UBOUND(control)
    IF control(iter).tree.parent = win.id THEN
      SELECT CASE control(iter).controlType
        CASE cWIN_CONTROL_LABEL, cWIN_CONTROL_BUTTON, cWIN_CONTROL_TOGGLE_BUTTON

          _DEST win.surface.primary
          _FONT settings.scrn.font
          IF control(iter).enabled THEN
            _PUTIMAGE (control(iter).position.x, control(iter).position.y), control(iter).surface.enable, win.surface.primary
          ELSE
            _PUTIMAGE (control(iter).position.x, control(iter).position.y), control(iter).surface.disable, win.surface.primary
          END IF

          _DEST win.surface.mouseSensitive
          LINE (control(iter).position.x + settings.win.borderThickness, _
                control(iter).position.y + _FONTHEIGHT + settings.win.borderThickness) _
              -(control(iter).position.x + control(iter).size.x + settings.win.borderThickness, _
                control(iter).position.y + control(iter).size.y + _FONTHEIGHT + settings.win.borderThickness), _
               _RGB32(cWINCONTROL, control(iter).userID, 0), BF
        CASE cWIN_CONTROL_RADIO_BUTTON
          _DEST win.surface.primary
          _FONT settings.scrn.font
          IF control(iter).enabled THEN
            _PUTIMAGE (control(iter).position.x, control(iter).position.y), control(iter).surface.enable, win.surface.primary
          ELSE
            _PUTIMAGE (control(iter).position.x, control(iter).position.y), control(iter).surface.disable, win.surface.primary
          END IF
          _DEST win.surface.mouseSensitive
          LINE (control(iter).position.x + settings.win.borderThickness, _
                control(iter).position.y + _FONTHEIGHT + settings.win.borderThickness) _
              -(control(iter).position.x + control(iter).size.x + settings.win.borderThickness, _
                control(iter).position.y + control(iter).size.y + _FONTHEIGHT + settings.win.borderThickness), _
               _RGB32(cWINCONTROL, control(iter).userID, 0), BF
      END SELECT
    END IF
    iter = iter + 1
  LOOP
END SUB

SUB renderWindows (general AS tGENERAL, settings AS tSETTINGS, surface AS tSURFACE, win() AS tWINDOW, iDevice AS tINPUTDEVICE, spriteMap() AS tSPRITESHEET, sprites() AS tSPRITE, control() AS tCONTROL)
  DIM AS LONG iter
  DIM AS tVECTOR2dl tempV
  _DEST surface.primary
  iter = 0
  iDevice.mouse.hoverOver = -1
  DO WHILE iter < UBOUND(win)
    IF general.updateAll OR win(iter).update THEN
      _DEST win(iter).surface.mouseSensitive
      CLS
      buildResizeBorder general, win(iter), settings
      buildTitleBar general, win(iter), settings, spriteMap()
      buildControl general, win(iter), control(), settings, spriteMap(), sprites()
      win(iter).update = cFALSE
    END IF

    IF AABBl(iDevice.mouse.position.x, iDevice.mouse.position.y, 1, 1, win(iter).position.x, win(iter).position.y, win(iter).size.x, win(iter).size.y) = cTRUE THEN
      IF iDevice.mouse.hoverOver = -1 THEN
        iDevice.mouse.hoverOver = iter
        tempV.x = iDevice.mouse.position.x - win(iter).position.x
        tempV.y = iDevice.mouse.position.y - win(iter).position.y
        _DEST win(iter).surface.mouseSensitive
        _SOURCE win(iter).surface.mouseSensitive
        iDevice.mouse.hoverOverElement = POINT(tempV.x, tempV.y)
      END IF
    END IF
    iter = iter + 1
  LOOP
  general.updateAll = cFALSE
  _DEST surface.primary
  _SOURCE surface.primary
  iter = iter - 1
  DO WHILE iter >= 0
    _PUTIMAGE (settings.win.borderThickness, _
               _FONTHEIGHT + (settings.win.borderThickness * 2) - 1), _
              win(iter).surface.primary, win(iter).surface.outer, _
              (0, 0)-(win(iter).size.x - (settings.win.borderThickness * 2), _
              win(iter).size.y - (settings.win.borderThickness * 3) - _FONTHEIGHT)
    _PUTIMAGE (win(iter).position.x, win(iter).position.y), win(iter).surface.outer, , (0, 0)-(win(iter).size.x, win(iter).size.y)
    iter = iter - 1
  LOOP
  IF iDevice.mouse.hoverOver = -1 THEN iDevice.mouse.hoverOverElement = -1
END SUB

FUNCTION findWinByID& (win() AS tWINDOW, id AS _INTEGER64)
  DIM AS LONG iter
  iter = 0
  DO WHILE iter < UBOUND(win) AND win(iter).id <> id
    iter = iter + 1
  LOOP
  IF win(iter).id = id THEN
    findWinByID = iter
  ELSE
    findWinByID = -1
  END IF
END FUNCTION

FUNCTION findWinIDByName&& (win() AS tWINDOW, nm AS STRING)
  DIM AS LONG iter
  iter = 0
  DO WHILE iter < UBOUND(win) AND trim$(win(iter).title) <> nm
    iter = iter + 1
  LOOP
  IF trim$(win(iter).title) = nm THEN
    findWinIDByName = win(iter).id
  ELSE
    findWinIDByName = -1
  END IF
END FUNCTION

FUNCTION findControl& (general AS tGENERAL, win() AS tWINDOW, control() AS tCONTROL, id AS LONG)
  DIM AS LONG iter
  iter = 0
  DO WHILE iter < UBOUND(control)
    IF control(iter).userID = id AND general.focus = control(iter).tree.parent THEN
      findControl = iter
      EXIT FUNCTION
    END IF
    iter = iter + 1
  LOOP
  findControl = -1
END FUNCTION


SUB winStackAddToTop (win() AS tWINDOW, w AS tWINDOW)
  REDIM _PRESERVE win(UBOUND(win) + 1) AS tWINDOW
  DIM AS LONG iter
  iter = UBOUND(win) - 1
  DO WHILE iter > 0
    win(iter) = win(iter - 1)
    iter = iter - 1
  LOOP
  win(0) = w
END SUB

SUB winStackAdd (win() AS tWINDOW, w AS tWINDOW)
  win(UBOUND(win)) = w
  REDIM _PRESERVE win(UBOUND(win) + 1) AS tWINDOW
END SUB

SUB winStackSwap (win() AS tWINDOW, w1 AS LONG, w2 AS LONG)
  SWAP win(w1), win(w2)
END SUB

SUB winDestroy (win() AS tWINDOW, w AS LONG)
  DIM AS LONG iter
  DIM AS _UNSIGNED _INTEGER64 id
  id = win(w).id
  iter = 0
  'recursively destroy child windows
  DO
    IF win(iter).tree.parent = id THEN
      winDestroy win(), iter
      iter = 0
    ELSE
      iter = iter + 1
    END IF
  LOOP WHILE iter < UBOUND(win)
  ' since the whole window list changes
  ' we have to find the window again
  iter = findWinByID&(win(), id)

  IF iter > -1 THEN
    _FREEIMAGE win(iter).surface.primary
    _FREEIMAGE win(iter).surface.mouseSensitive
    _FREEIMAGE win(iter).surface.outer

    DO WHILE iter < UBOUND(win)
      win(iter) = win(iter + 1)
      iter = iter + 1
    LOOP
    REDIM _PRESERVE win(UBOUND(win) - 1) AS tWINDOW
  END IF
END SUB

SUB winSetTitle (general AS tGENERAL, win() AS tWINDOW, settings AS tSETTINGS, spriteMap() AS tSPRITESHEET, sprites() AS tSPRITE, id AS LONG, title AS STRING)
  DIM AS LONG iter
  iter = findWinByID(win(), id)
  IF iter > -1 THEN
    win(iter).title = title
    buildTitleBar general, win(iter), settings, spriteMap()
    PRINT iter: _DELAY 5
  END IF
END SUB


SUB ________MATH_ROUTINES (): END SUB

FUNCTION lerp1Ds! (current AS SINGLE, target AS SINGLE, inc AS SINGLE)
  lerp1Ds = current + (target - current) * inc
END FUNCTION

SUB lerpVec2Ds (current AS tVECTOR2dl, target AS tVECTOR2dl, inc AS SINGLE)
  current.x = lerp1Ds(current.x, target.x, inc)
  current.y = lerp1Ds(current.y, target.y, inc)
END SUB

FUNCTION AABBl%% (Ax AS LONG, Ay AS LONG, Aw AS LONG, Ah AS LONG, Bx AS LONG, By AS LONG, Bw AS LONG, Bh AS LONG)
  AABBl = Ax < Bx + Bw AND Ax + Aw > Bx AND Ay < By + Bh AND Ay + Ah > By
END FUNCTION

FUNCTION adjustColor& (c AS LONG, percentage AS SINGLE)
  adjustColor = _RGB(_RED(c) * percentage, _GREEN(c) * percentage, _BLUE(c) * percentage)
END FUNCTION

SUB ________FILE_ROUTINES (): END SUB

SUB loadFile (file AS STRING, filetext AS STRING)
  DIM AS LONG fileHandle, fileSize
  IF _FILEEXISTS(file) THEN
    fileHandle = FREEFILE
    filetext = ""
    ' Open file just to retrieve its length
    OPEN file FOR INPUT AS #fileHandle
    fileSize = LOF(fileHandle)
    CLOSE #fileHandle
    ' Now open it for real
    OPEN file FOR RANDOM AS #fileHandle LEN = fileSize
    FIELD #fileHandle, fileSize AS filetext
    GET #fileHandle, 1
    CLOSE #fileHandle
  ELSE
    PRINT "File '"; file; "' does not exist."
    END
  END IF
END SUB

SUB loadFilebyLine (fl AS STRING, filetext() AS STRING)
  fl = LTRIM$(RTRIM$(fl)) 'clean the filename
  DIM AS LONG file_num
  IF _FILEEXISTS(fl) THEN
    file_num = FREEFILE
    OPEN fl FOR INPUT AS #file_num
    DO UNTIL EOF(file_num)
      LINE INPUT #file_num, filetext(UBOUND(filetext))
      REDIM _PRESERVE filetext(UBOUND(filetext) + 1) AS STRING
    LOOP
    CLOSE file_num
  ELSE
    PRINT "File not found :"; fl
    END
  END IF
END SUB


SUB _____OS_RELATED: END SUB

'-------------------------------------------------------
' Usage Example:
' DIM file(0) AS STRING * 256
' DIM AS INTEGER i
' OSDirectoryListing os,"/..", "", file()
' FOR i = 0 TO UBOUND(file)
'   PRINT trim$(file(i))
' NEXT
'-------------------------------------------------------

SUB OSDirectoryListing (os AS tOS, directory AS STRING, wildcard AS STRING, file() AS STRING * 256)
  DIM AS STRING tempFile, tempCommand
  REDIM file(0) AS STRING * 256
  DIM AS INTEGER availableFile
  IF _DIREXISTS(directory) THEN
    availableFile = FREEFILE
    tempFile = "dir_list.txt"
    tempCommand = trim$(os.fileListCommand) + " "
    tempCommand = tempCommand + directory + os.pathSeparator
    IF os.osEnum = cOS_LINUX OR os.osEnum = cOS_MACOSX THEN
      tempCommand = tempCommand + " "
    END IF
    tempCommand = tempCommand + wildcard
    tempCommand = tempCommand + " > " + trim$(os.workingDirectory) + os.pathSeparator$ + tempFile
    IF _FILEEXISTS(_CWD$ + os.pathSeparator$ + tempFile) THEN
      KILL trim$(os.workingDirectory) + os.pathSeparator + tempFile
    END IF
    SHELL _HIDE tempCommand
    IF _FILEEXISTS(_CWD$ + os.pathSeparator$ + tempFile) THEN
      OPEN _CWD$ + os.pathSeparator$ + tempFile FOR INPUT AS #availableFile
      DO UNTIL EOF(availableFile)
        INPUT #availableFile, file(UBOUND(file))
        REDIM _PRESERVE file(UBOUND(file) + 1) AS STRING * 256
      LOOP
      CLOSE #availableFile
      KILL trim$(os.workingDirectory) + os.pathSeparator + tempFile
    END IF
  END IF
END SUB

SUB OSinit (os AS tOS)
  os.os = _OS$
  os.workingDirectory = _CWD$
  IF INSTR(_OS$, "[WINDOWS]") THEN
    os.fileListCommand = "dir"
    os.pathSeparator = "\"
    os.osEnum = cOS_WIN
  ELSE IF INSTR(_OS$, "[LINUX]") THEN
      os.fileListCommand = "ls -p --group-directories-first" ' ls -Rl | grep '.ttf'
      os.pathSeparator = "/"
      os.osEnum = cOS_LINUX
    ELSE IF INSTR(_OS$, "[MACOSX]") THEN
        os.fileListCommand = "ls -la"
        os.pathSeparator = "/"
        os.osEnum = cOS_MACOSX
      END IF
    END IF
  END IF
END SUB

'-------------------------------------------------------
' Misc Utility Functions
'-------------------------------------------------------

SUB _____MISC (): END SUB

FUNCTION trim$ (s AS STRING)
  trim$ = RTRIM$(LTRIM$(s))
END FUNCTION

FUNCTION isAlpha (c AS STRING)
  isAlpha = (ASC(c) >= 65 AND ASC(c) <= 90) OR ((ASC(c) >= 97) AND (ASC(c) <= 122))
END FUNCTION

FUNCTION isDigit (c AS STRING)
  isDigit = (ASC(c) >= 48 AND ASC(c) <= 57)
END FUNCTION

FUNCTION isSymbol (c AS STRING)
  isSymbol = NOT (isAlpha(c) OR isDigit(c))
END FUNCTION


'-------------------------------------------------------
' String Hash
'-------------------------------------------------------
SUB _____GENERAL_STRING_HASH (): END SUB
FUNCTION computeHash&& (s AS STRING)
  DIM p, i AS LONG: p = 31
  DIM m AS _INTEGER64: m = 1E9 + 9
  DIM AS _INTEGER64 hash_value, p_pow
  p_pow = 1
  FOR i = 1 TO LEN(s)
    hash_value = (hash_value + (ASC(MID$(s, i)) - 97 + 1) * p_pow)
    p_pow = (p_pow * p) MOD m
  NEXT
  computeHash = hash_value
END FUNCTION

FUNCTION uniqueNumber&& ()
  RANDOMIZE TIMER
  uniqueNumber = INT(TIMER(.001) * 1000) OR ((RND * 1000) * 10000000000)
END FUNCTION

'-------------------------------------------------------
' Unicode
'-------------------------------------------------------

SUB _____UNICODE (): END SUB

'-------------------------------------------------------
' Usage Example:
'DIM AS LONG fontHandle, scr
'scr = _NEWIMAGE(1024, 768, 32)
'SCREEN scr
'_PRINTMODE _KEEPBACKGROUND
'DIM AS STRING fontFile
'fontFile = _CWD$ + os.pathSeparator + "Apl385.ttf"
'fontHandle = _LOADFONT(fontFile, 24)
'_FONT fontHandle
'DIM testString AS STRING
'testString = "gol ← {≢⍸⍵}⌺3 3∊¨3+0,¨⊢ ⍝ Generate the next generation"
'printUnicode testString
'-------------------------------------------------------

SUB printUnicode (s AS STRING)
  DIM AS INTEGER index
  DIM AS LONG unicode
  index = 1
  DO
    unicode = UTF(s, index)
    IF unicode > 127 THEN
      _MAPUNICODE unicode TO 255
      PRINT CHR$(255);
    ELSE
      PRINT CHR$(unicode);
    END IF
  LOOP UNTIL index > LEN(s)
END SUB


FUNCTION UTF~& (s AS STRING, index AS INTEGER)
  DIM AS _UNSIGNED LONG unicode
  DIM AS _UNSIGNED _BYTE b1, b2, b3, b4
  unicode = 0
  IF index <= LEN(s) THEN
    b1 = ASC(MID$(s, index, 1))
    IF NOT _READBIT(b1, 7) THEN
      index = index + 1
      unicode = b1
    ELSE
      IF _READBIT(b1, 7) AND _READBIT(b1, 6) AND NOT _READBIT(b1, 5) THEN
        IF index + 1 > LEN(s) THEN ERROR 9
        b1 = b1 AND &H1F
        b2 = ASC(MID$(s, index + 1, 1)) AND &H3F
        unicode = _SHL(b1, 6) OR b2
        index = index + 2
      ELSE
        IF _READBIT(b1, 7) AND _READBIT(b1, 6) AND _READBIT(b1, 5) AND NOT _READBIT(b1, 4) THEN
          IF index + 2 > LEN(s) THEN ERROR 9
          b1 = b1 AND &H0F
          b2 = ASC(MID$(s, index + 1, 1)) AND &H3F
          b3 = ASC(MID$(s, index + 2, 1)) AND &H3F
          unicode = _SHL(b1, 12) OR _SHL(b2, 6) OR b3
          index = index + 3
        ELSE
          IF _READBIT(b1, 7) AND _READBIT(b1, 6) AND _READBIT(b1, 5) AND _READBIT(b1, 4) AND NOT _READBIT(b1, 3) THEN
            IF index + 3 > LEN(s) THEN ERROR 9
            b1 = b1 AND &H07
            b2 = ASC(MID$(s, index + 1, 1)) AND &H3F
            b3 = ASC(MID$(s, index + 2, 1)) AND &H3F
            b4 = ASC(MID$(s, index + 3, 1)) AND &H3F
            unicode = _SHL(b1, 18) OR _SHL(b2, 12) OR _SHL(b3, 6) OR b4
            index = index + 4
          ELSE
            ERROR 150: END
          END IF
        END IF
      END IF
    END IF
  END IF
  UTF = unicode
END FUNCTION

SUB _____SPRITE_STUFF (): END SUB

SUB colorBWSprite (img AS LONG, foreground AS LONG, background AS LONG)
  DIM AS _OFFSET iter, length
  DIM AS _MEM memIMG
  DIM AS LONG c
  memIMG = _MEMIMAGE(img)
  iter = memIMG.OFFSET
  length = iter + memIMG.SIZE
  DO WHILE iter < length
    IF _MEMGET(memIMG, iter, _UNSIGNED _BYTE) THEN ' I can just check one channel because images are B/W
      c = foreground
    ELSE
      c = background
    END IF
    _MEMPUT memIMG, iter + 0, _BLUE(c) AS _UNSIGNED _BYTE
    _MEMPUT memIMG, iter + 1, _GREEN(c) AS _UNSIGNED _BYTE
    _MEMPUT memIMG, iter + 2, _RED(c) AS _UNSIGNED _BYTE
    _MEMPUT memIMG, iter + 3, _ALPHA(c) AS _UNSIGNED _BYTE
    iter = iter + 4
  LOOP
  _MEMFREE memIMG
END SUB

SUB _____INI_HANDLING (): END SUB

SUB init (settings AS tSETTINGS, con() AS tSTRINGTUPLE, os AS tOS, sprite() AS tSPRITESHEET, sprites() AS tSPRITE)
  DIM AS LONG iter, tempL, tempL1, arraySize
  DIM AS _FLOAT tempF
  DIM AS STRING context, argument, tempS
  iter = 0
  FOR iter = 0 TO UBOUND(con) - 1
    context = trim$(con(iter).contextName)
    argument = trim$(con(iter).arg)
    SELECT CASE context
      CASE "GENERALUI MOUSE"
        tempF = getXMLArgValue##(argument, " DOUBLECLICKDELAY=")
        settings.mouse.doubleclickdelay = tempF
      CASE "GENERALUI SCREEN TITLE"
        _TITLE getXMLArgString(argument, " name=")
      CASE "GENERALUI SCREEN SIZE"
        settings.scrn.w = getXMLArgValue##(argument, " width=")
        settings.scrn.h = getXMLArgValue##(argument, " height=")
        settings.scrn.bpp = getXMLArgValue##(argument, " bpp=")
        settings.scrn.fullscreen = getXMLArgValue##(argument, " fullscreen=")
        IF settings.scrn.w = -1 OR settings.scrn.h = -1 THEN
          settings.scrn.w = _DESKTOPWIDTH
          settings.scrn.h = _DESKTOPHEIGHT
        END IF
        IF settings.scrn.fullscreen THEN _FULLSCREEN _SQUAREPIXELS , _SMOOTH
      CASE "GENERALUI SCREEN COLOR"
        settings.scrn.background = _RGB32(getXMLArgValue##(argument, " red="), getXMLArgValue##(argument, " green="), getXMLArgValue##(argument, " blue="))
      CASE "GENERALUI SCREEN FONT"
        tempS = _CWD$ + os.pathSeparator + "fonts" + os.pathSeparator + trim$(getXMLArgString(argument, " name="))
        tempL = getXMLArgValue##(argument, " size=")
        tempL1 = _LOADFONT(tempS, tempL, "MONOSPACE")
        _FONT tempL1
        settings.scrn.font = tempL1
        settings.scrn.fontSize = tempL
      CASE "GENERALUI WINDOW BORDER COLOR"
        settings.win.elementColor = _RGB32(getXMLArgValue##(argument, " red="), getXMLArgValue##(argument, " green="), getXMLArgValue##(argument, " blue="))
      CASE "GENERALUI WINDOW BORDER CORNER_SIZE"
        settings.win.cornerSize = getXMLArgValue##(argument, " size=")
      CASE "GENERALUI WINDOW BORDER THICKNESS"
        settings.win.borderThickness = getXMLArgValue##(argument, " size=")
      CASE "GENERALUI ICONS SPRITESHEET FILE"
        arraySize = UBOUND(sprite)
        sprite(arraySize).file = getXMLArgString$(argument, " file=")
        sprite(arraySize).spritePadding = getXMLArgValue##(argument, " padding=")
        sprite(arraySize).numberOfSpritesX = getXMLArgValue##(argument, " x=")
        sprite(arraySize).numberOfSpritesY = getXMLArgValue##(argument, " y=")
        sprite(arraySize).spriteWidth = getXMLArgValue##(argument, " w=")
        sprite(arraySize).spriteHeight = getXMLArgValue##(argument, " h=")
        tempS = _CWD$ + os.pathSeparator + "icons" + os.pathSeparator + trim$(sprite(arraySize).file)
        sprite(arraySize).spriteMap = _LOADIMAGE(tempS, 32)
        sprite(arraySize).mapWidth = _WIDTH(sprite(arraySize).spriteMap)
        sprite(arraySize).mapHeight = _HEIGHT(sprite(arraySize).spriteMap)
        REDIM _PRESERVE sprite(arraySize + 1) AS tSPRITESHEET
      CASE "GENERALUI ICONS IDS ID"
        arraySize = UBOUND(sprites)
        sprites(arraySize).spriteName = getXMLArgString$(argument, " name=")
        sprites(arraySize).sprite = getXMLArgValue##(argument, " id=")
        sprites(arraySize).hash = computeHash(sprites(arraySize).spriteName)
        REDIM _PRESERVE sprites(arraySize + 1) AS tSPRITE
    END SELECT
  NEXT
END SUB


SUB initWin (general AS tGENERAL, win() AS tWINDOW, control() AS tCONTROL, settings AS tSETTINGS, con() AS tSTRINGTUPLE, spritemap() AS tSPRITESHEET, sprites() AS tSPRITE)
  DIM AS LONG iter
  DIM AS STRING context, argument
  DIM AS tWINDOW tempW
  DIM AS tCONTROL tempC
  DIM AS _UNSIGNED _BYTE r, g, b
  iter = 0
  FOR iter = 0 TO UBOUND(con) - 1
    context = trim$(con(iter).contextName)
    argument = trim$(con(iter).arg)
    SELECT CASE context
      CASE "WINDOW WIN PROPERTIES"
        tempW.title = getXMLArgString$(argument, " name=")
        tempW.tree.parent = getXMLArgValue##(argument, " parent=")
        tempW.attrib = getXMLArgValue##(argument, " attrib=")
        tempW.position.x = getXMLArgValue##(argument, " posx=")
        tempW.position.y = getXMLArgValue##(argument, " posy=")
        tempW.size.x = getXMLArgValue##(argument, " sizex=")
        tempW.size.y = getXMLArgValue##(argument, " sizey=")
        r = getXMLArgValue##(argument, " colorRed=")
        g = getXMLArgValue##(argument, " colorGreen=")
        b = getXMLArgValue##(argument, " colorBlue=")
        tempW.surface.defaultColor = _RGB32(r, g, b)
        createWindowEx general, settings, win(), spritemap(), sprites(), tempW
      CASE "WINDOW WIN CONTROL"
        tempC.elementName = getXMLArgString$(argument, " name=")
        tempC.elementText.text = getXMLArgString$(argument, " text=")

        tempC.elementText.attrib = getXMLArgValue##(argument, " attrib=")
        tempC.id = uniqueNumber
        tempC.style = getXMLArgValue##(argument, " style=")
        tempC.userID = getXMLArgValue##(argument, " id=")
        tempC.enabled = getXMLArgValue##(argument, " enable=")
        tempC.position.x = getXMLArgValue##(argument, " posx=")
        tempC.position.y = getXMLArgValue##(argument, " posy=")
        tempC.size.x = getXMLArgValue##(argument, " sizex=")
        tempC.size.y = getXMLArgValue##(argument, " sizey=")
        tempC.elementText.maxLen = INT(tempC.size.x / _PRINTWIDTH("W"))
        tempC.tree.id = tempC.id
        tempC.tree.parent = findWinIDByName(win(), trim$(tempW.title))
        tempC.controlType = getXMLArgValue##(argument, " type=")
        r = getXMLArgValue##(argument, " textColorRed=")
        g = getXMLArgValue##(argument, " textColorGreen=")
        b = getXMLArgValue##(argument, " textColorBlue=")
        tempC.textColor = _RGB32(r, g, b)
        r = getXMLArgValue##(argument, " controlColorRed=")
        g = getXMLArgValue##(argument, " controlColorGreen=")
        b = getXMLArgValue##(argument, " controlColorBlue=")
        tempC.controlColor = _RGB32(r, g, b)
        r = getXMLArgValue##(argument, " enableColorRed=")
        g = getXMLArgValue##(argument, " enableColorGreen=")
        b = getXMLArgValue##(argument, " enableColorBlue=")
        tempC.enableColor = _RGB32(r, g, b)
        buildControlEx general, tempC, settings, spritemap(), sprites()
        pushStackControl control(), tempC
    END SELECT
  NEXT

END SUB

SUB _____XML_HANDLING (): END SUB

SUB XMLparse (file AS STRING, con() AS tSTRINGTUPLE)
  DIM AS STRING xml(0), x, element_name, stack(0), context
  DIM AS LONG index
  DIM AS LONG element_start, element_ending
  DIM AS LONG element_first_space, element_pop
  DIM AS LONG element_end_of_family, element_no_family
  DIM AS LONG header_start, header_finish
  DIM AS LONG element_name_start, element_name_end
  DIM AS LONG comment_start, comment_end, comment_multiline_start, comment_multiline_end
  DIM AS LONG mute, j

  loadFilebyLine trim$(file), xml()

  mute = 0

  FOR index = 0 TO UBOUND(xml) - 1
    x = RTRIM$(LTRIM$(xml(index)))
    header_start = INSTR(x, "<?")
    header_finish = INSTR(x, "?>")
    comment_start = INSTR(x, "<!")
    comment_end = INSTR(x, "!>")
    comment_multiline_start = INSTR(x, "<!--")
    comment_multiline_end = INSTR(x, "-->")
    IF comment_start OR comment_multiline_start THEN mute = 1
    IF comment_end OR comment_multiline_end THEN mute = 0

    IF header_start = 0 AND mute = 0 THEN
      element_start = INSTR(x, "<")
      element_end_of_family = INSTR(x, "</")
      element_first_space = INSTR(element_start, x, " ")
      element_pop = INSTR(x, "/")
      element_ending = INSTR(x, ">")
      element_no_family = INSTR(x, "/>")
      element_name = ""
      IF element_start THEN
        'Get Element Name
        'Starting character
        IF element_end_of_family THEN
          element_name_start = element_end_of_family + 2 'start after '</'
        ELSE
          element_name_start = element_start + 1 'start after '<'
        END IF
        'Ending character
        IF element_first_space THEN ' check for a space after the element name
          element_name_end = element_first_space
        ELSE
          IF element_no_family THEN ' check for no family
            element_name_end = element_no_family
          ELSE
            IF element_ending THEN ' check for family name
              element_name_end = element_ending
            ELSE
              PRINT "XML malformed. "; x
              END
            END IF
          END IF
        END IF
        element_name = MID$(x, element_name_start, element_name_end - element_name_start)
        ' Determine level
        IF element_end_of_family = 0 THEN
          pushStackString stack(), element_name
          ' Compile context tree
          context = ""
          FOR j = 0 TO UBOUND(stack) - 1 'push_pop
            context = context + stack(j)
            IF j < UBOUND(stack) - 1 THEN
              context = context + " "
            END IF
          NEXT
        END IF
        IF element_pop THEN popStackString stack()
      END IF
      ' push onto Context tuple
      IF element_end_of_family = 0 THEN pushStackContextArg con(), context, x
    END IF
  NEXT
END SUB

FUNCTION getXMLArgValue## (i AS STRING, s AS STRING)
  DIM AS LONG sp, space
  DIM AS STRING m
  sp = INSTR(i, s)
  IF sp THEN
    sp = sp + LEN(s) + 1 ' add one for the quotes
    space = INSTR(sp + 1, i, CHR$(34)) - sp
    m = MID$(i, sp, space)
    getXMLArgValue## = VAL(m)
  END IF
END FUNCTION

FUNCTION getXMLArgString$ (i AS STRING, s AS STRING)
  DIM AS LONG sp, space
  DIM AS STRING m
  sp = INSTR(i, s)
  IF sp THEN
    sp = sp + LEN(s) + 1 ' add one for the quotes
    space = INSTR(sp + 1, i, CHR$(34)) - sp
    m = MID$(i, sp, space)
    getXMLArgString$ = RTRIM$(LTRIM$(m))
  END IF
END FUNCTION

'**********************************************************************************************
'   Stack Functions/Subs
'**********************************************************************************************
SUB ______STACK_HANDLING (): END SUB

SUB pushStackString (stack() AS STRING, element AS STRING)
  stack(UBOUND(stack)) = element
  REDIM _PRESERVE stack(UBOUND(stack) + 1) AS STRING
END SUB

SUB popStackString (stack() AS STRING)
  IF UBOUND(stack) > 0 THEN REDIM _PRESERVE stack(UBOUND(stack) - 1) AS STRING
END SUB

FUNCTION topStackString$ (stack() AS STRING)
  IF UBOUND(stack) > 0 THEN
    topStackString$ = stack(UBOUND(stack) - 1)
  ELSE
    topStackString$ = stack(UBOUND(stack))
  END IF
END FUNCTION

SUB pushStackContextArg (stack() AS tSTRINGTUPLE, element_name AS STRING, element AS STRING)
  stack(UBOUND(stack)).contextName = element_name
  stack(UBOUND(stack)).arg = element
  REDIM _PRESERVE stack(UBOUND(stack) + 1) AS tSTRINGTUPLE
END SUB

SUB pushStackContext (stack() AS tSTRINGTUPLE, element AS tSTRINGTUPLE)
  stack(UBOUND(stack)) = element
  REDIM _PRESERVE stack(UBOUND(stack) + 1) AS tSTRINGTUPLE
END SUB

SUB popStackContext (stack() AS tSTRINGTUPLE)
  IF UBOUND(stack) > 0 THEN REDIM _PRESERVE stack(UBOUND(stack) - 1) AS tSTRINGTUPLE
END SUB

SUB pushStackSprite (stack() AS tSPRITE, element AS tSPRITE)
  stack(UBOUND(stack)) = element
  REDIM _PRESERVE stack(UBOUND(stack) + 1) AS tSPRITE
END SUB

SUB pushStackControl (stack() AS tCONTROL, element AS tCONTROL)
  stack(UBOUND(stack)) = element
  REDIM _PRESERVE stack(UBOUND(stack) + 1) AS tCONTROL
END SUB

'**********************************************************************************************
'   Texture Loading
'**********************************************************************************************
SUB _______________TEXTURE_HANDLING (): END SUB

FUNCTION spriteNameToID (sprites() AS tSPRITE, spriteName AS STRING)
  DIM AS LONG iter
  DO WHILE iter < UBOUND(sprites)
    IF trim$(sprites(iter).spriteName) = spriteName THEN
      spriteNameToID = sprites(iter).sprite
      EXIT FUNCTION
    END IF
    iter = iter + 1
  LOOP
END FUNCTION

SUB spriteMapImagePosition (spriteNumber AS LONG, t AS tSPRITESHEET, q AS tQUAD)
  DIM sprite_width AS LONG
  DIM sprite_height AS LONG
  DIM sprite_x, sprite_y AS LONG

  sprite_width = t.spriteWidth + t.spritePadding
  sprite_height = t.spriteHeight + t.spritePadding

  sprite_x = spriteNumber MOD t.numberOfSpritesX
  sprite_y = INT(spriteNumber / t.numberOfSpritesX)

  q.a.x = sprite_x * sprite_width
  q.a.y = sprite_y * sprite_height

  q.b.x = q.a.x + t.spriteWidth - t.spritePadding
  q.b.y = q.a.y + t.spriteHeight - t.spritePadding
END SUB

SUB _______________FSM_HANDLING (): END SUB

SUB FSMChangeState (fsm AS tFSM, newState AS LONG)
  fsm.previousState = fsm.currentState
  fsm.currentState = newState
  fsm.timerState.start = TIMER(.001)
END SUB

SUB FSMChangeStateEx (fsm AS tFSM, newState AS LONG, arg1 AS tVECTOR2dl, arg2 AS tVECTOR2dl, arg3 AS LONG)
  fsm.previousState = fsm.currentState
  fsm.currentState = newState
  fsm.arg1 = arg1
  fsm.arg2 = arg2
  fsm.arg3 = arg3
END SUB

SUB FSMChangeStateOnTimer (fsm AS tFSM, newstate AS LONG)
  IF TIMER(.001) > fsm.timerState.start + fsm.timerState.duration THEN
    FSMChangeState fsm, newstate
  END IF
END SUB

SUB ________DRAWING_ROUTINES (): END SUB

SUB CircleBresenham (xc AS LONG, yc AS LONG, r AS LONG, c AS LONG, style AS _BYTE)
  DIM AS LONG e, x, y, w
  DIM AS LONG l0, l1
  w = _WIDTH(0) * 4
  x = r
  y = 0
  e = 0
  $CHECKING:OFF
  DO
    l0 = x + x
    l1 = y + y
    IF style = cCIRCLE_STYLE_FILLED THEN
      LINE (xc - x, yc - y)-(xc - x + l0, yc - y), c
      LINE (xc - x, yc + y)-(xc - x + l0, yc + y), c
      LINE (xc - y, yc - x)-(xc - y + l1, yc - x), c
      LINE (xc - y, yc + x)-(xc - y + l1, yc + x), c
    ELSE IF style = cCIRCLE_STYLE_NOFILL THEN
        PSET (xc - x, yc - y), c: PSET (xc - x + l0, yc - y), c
        PSET (xc - x, yc + y), c: PSET (xc - x + l0, yc + y), c
        PSET (xc - y, yc - x), c: PSET (xc - y + l1, yc - x), c
        PSET (xc - y, yc + x), c: PSET (xc - y + l1, yc + x), c
      END IF
    END IF
    IF x <= y THEN EXIT DO
    e = e + y + y + 1
    y = y + 1
    IF e > x THEN
      e = e + 1 - (x + x)
      x = x - 1
    END IF
  LOOP
  $CHECKING:ON
END SUB

